
local lua51 = loadstring("return function(...) return ... end") and true or false

local validtypes = {
	string = true,
	number = true,
}
local colors = {"|cffff88ff", "|cff88ffff", "|cffffff88"}
local mod = lua51 and math.fmod or math.mod
local cf = ChatFrame5


-------------------------------------
--      Namespace Declaration      --
-------------------------------------

Kyubi = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0")
Kyubi:RegisterDB("KyubiDB")

function Kyubi:OnInitialize()
	self:RegisterDefaults('profile', {
		filters = {},
	})
	self:RegisterChatCommand({'/kyubi'}, {
		type = 'group',
		args = {
			AddFilter = {
				name = "Add Filter",
				type = 'text',
				desc = "Add a new event filter regex",
				usage = "<any string>",
				get = false,
				set = function(v)
					table.insert(self.db.profile.filters, v)
				end,
				validate = borderList,
				order = 1,
			},
			DeleteFilter = {
				name = "Delete Filter",
				type = 'text',
				desc = "Delete a regex filter",
				get = false,
				set = function(v)
					local i
					for idx,val in ipairs(self.db.profile.filters) do if v == val then i = idx end end
					if i then table.remove(self.db.profile.filters, i) end
				end,
				validate = self.db.profile.filters,
				order = 2,
				disabled = function() return not next(self.db.profile.filters) end,
			},
		}
	})
end


---------------------------
--      Ace Methods      --
---------------------------

function Kyubi:OnEnable()
	self:RegisterAllEvents("EventsHandler")
end


-----------------------------
--      Event Handler      --
-----------------------------

local colorize = function(txt, i)
	local t = type(txt)
	return txt and (colors[mod(i,3)+1].. " | arg "..(i == "" and "<empty string>" or i)..": "..(validtypes[t] and txt or t == "boolean" and (txt and "true" or "false") or "<"..t..">")) or ""
end


local function myconcat(i, a1, ...)
	if not a1 then return ""
	else return colorize(a1,i)..myconcat(i+1, ...) end
end


if lua51 then
	function Kyubi:EventsHandler(...)
		if not self:IsShown(event) then return end

		cf:AddMessage("|cffff8888".. event..myconcat(1, ...))
	end
else
	function Kyubi:EventsHandler(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20)
		if not self:IsShown(event) then return end

		cf:AddMessage("|cffff8888".. event..
			colorize(a1,1)..colorize(a2,2)..colorize(a3,3)..colorize(a4,4)..colorize(a5,5)..
			colorize(a6,6)..colorize(a7,7)..colorize(a8,8)..colorize(a9,9)..colorize(a10,10)..
			colorize(a11,11)..colorize(a12,12)..colorize(a13,13)..colorize(a14,14)..colorize(a15,15)..
			colorize(a16,16)..colorize(a17,17)..colorize(a18,18)..colorize(a19,19)..colorize(a20,20))
	end
end


function Kyubi:IsShown(event)
	if not event then return end

	if not next(self.db.profile.filters) then return true end
	for i,v in pairs(self.db.profile.filters) do
		if string.find(event, v) then return true end
	end
end

